#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <ostream>
#include <istream>
#include <sstream>
#include <omp.h>
//#include "advisor-annotate.h"

using namespace std;

#define NP 100000

double U_new[NP+1];
double U_old[NP+1];
double malha_x[NP+1];
//omp_lock_t lock[240];
int lock[240];

double x , deltaX , velX , tempoFinal , deltaT , alfa , beta , gama;
double t_ini , t_fim;


long int N , contagemTempo;
int myRank , numProcs;

double pulso (double D , double xo , double x) {
	return (exp(-D*((x-xo)*(x-xo))));
}


int main (int argc , char * argv[]){

	N = NP+1;
  	deltaX = (double) 1/(N-1);
	
	for (int i = 0 ; i <= N-1 ; i++) {
		x = (double) i*deltaX;
        	malha_x[i] = x;
        	U_old[i] = pulso (100 , 0.2 , x);
  	}

  	gama = atof(argv[1]);
  	tempoFinal = atof(argv[2]);
 	deltaT = atof(argv[3]);
  	velX = atof(argv[4]);

  	alfa = (gama*deltaT)/(deltaX*deltaX);  


	//Impressão U_inicial
/*	cout << "U_inicial = [";
	for (int i = 0; i < N-1; i+=10)
		cout << B[i] << " ";
	cout << "];" << endl;	
*/


	t_ini = omp_get_wtime();


        #pragma omp parallel
        {

  		int k = 0;
		int head = 1;
		double tempo = 0;

		int tid = omp_get_thread_num();
		int nt = omp_get_num_threads();
		int size = (N-2)/nt;
		int resto = (N-2)%nt;
		int inicioLocal = tid*size + 1;
		int finalLocal = inicioLocal + size - 1;
		if (tid == (nt-1))
			finalLocal = finalLocal + resto;


		int nid = tid + 1;
		lock[nid] = 0;
		#pragma omp master
		{
			lock[0] = 0;
			lock[nt+1] = 0;

		}
		//omp_unset_lock(&lock[0]);
		//omp_unset_lock(&lock[nt+1]);

		#pragma omp flush (lock)
		#pragma omp barrier

		// printf ("thread %d inicio %d fim %d \n" , tid , inicioLocal , finalLocal);
		
		
		while (tempo < tempoFinal){


			#pragma omp atomic write
			lock[nid] = 1;

	      		// Calcula a informacao no pe da caracteristica e atualiza a matriz com esse valor
	      		#pragma simd
			for (int i = inicioLocal ; i <= finalLocal ; i++) {
				//ANNOTATE_ITERATION_TASK(loop_MMOC);
				double deltaXtil = (double) velX*deltaT;
				int delta = floor (deltaXtil/deltaX);
	        		double x1 = (double) (i-delta)*deltaX;
	            		double xo = (double) x1 - deltaX;
	            		double xTil = (double) i*deltaX - deltaXtil;
				if (i - delta - 1 >= 0) {
	            			U_new[i] = ((x1 - xTil)*U_old[i- delta - 1] + (xTil - xo)*U_old[i - delta])/(deltaX);
				} else {
					U_new[i] = U_old[0];
				}
	      		}

			#pragma omp atomic write
			lock[nid] = 0;

			while ((lock[nid+1] == 1) || (lock[nid-1] == 1));




			//&& (omp_test_lock (&lock[nid+1])))
			//{cout << "thread " << nid << " travada " << endl;};

			//omp_unset_lock(&lock[nid-1]);
			//omp_unset_lock(&lock[nid+1]);

			#pragma omp atomic write
			lock[nid] = 1;

			#pragma simd
	      		for (int i = inicioLocal+head+1 ; i <= finalLocal; i+=2) {
				//ANNOTATE_ITERATION_TASK(loop_HOP_EXP_1);
		    		U_old[i] = alfa*(U_new[i-1] + U_new[i+1]) + (1 - 2*alfa)*U_new[i];
	      		}

			#pragma omp atomic write
			lock[nid] = 0;

			while ((lock[nid+1] == 1) || (lock[nid-1] == 1));		

			//#pragma omp critical
			//{
				//lock[nid] = 1;
			//}

			//#pragma omp barrier
	
			head = (head+1)%2;

			#pragma omp atomic write
			lock[nid] = 1;				
	
			#pragma simd
	      		for (int i = inicioLocal+head+1 ; i <= finalLocal; i+=2) {       
				//ANNOTATE_ITERATION_TASK(loop_HOP_IMP_1);
		    		U_old[i] = (U_new[i] + alfa*U_old[i-1] + alfa*U_old[i+1])/(1+2*alfa);
	     		}
			#pragma omp atomic write
			lock[nid] = 0;

			while ((lock[nid+1] == 1) || (lock[nid-1] == 1));	

			head = (head+1)%2;



			#pragma omp atomic write
			lock[nid] = 1;	

	                #pragma simd
	      		for (int i = inicioLocal+head+1 ; i <= finalLocal; i+=2) {
				//ANNOTATE_ITERATION_TASK(loop_HOP_EXP_2);
		    		U_new[i] = alfa*(U_old[i-1] + U_old[i+1]) + (1 - 2*alfa)*U_old[i];
	      		}

			#pragma omp atomic write
			lock[nid] = 0;	

			while ((lock[nid+1] == 1) || (lock[nid-1] == 1));	

			head = (head+1)%2;



			#pragma omp atomic write
			lock[nid] = 1;	

	                #pragma simd
	      		for (int i = inicioLocal+head+1 ; i <= finalLocal; i+=2) {    
				//ANNOTATE_ITERATION_TASK(loop_HOP_IMP_2);   
		    		U_new[i] = (U_old[i] + alfa*U_new[i-1] + alfa*U_new[i+1])/(1+2*alfa);
	     		}

			#pragma omp atomic write
			lock[nid] = 0;

			while ((lock[nid+1] == 1) || (lock[nid-1] == 1));		


                        head = (head+1)%2;

			#pragma omp atomic write
			lock[nid] = 1;

			#pragma simd
	      		for (int i = inicioLocal ; i <= finalLocal; i++) {       
				//ANNOTATE_ITERATION_TASK(loop_attribute);
		    		U_old[i] = U_new[i];
	     		}
	
		      	k++;
		        tempo = (double) (k*deltaT);

			#pragma omp atomic write
			lock[nid] = 0;

			while ((lock[nid+1] == 1) || (lock[nid-1] == 1));	
	  	}

		

		//ANNOTATE_SITE_END();

	}

        t_fim = omp_get_wtime();
  
	/* IMPRESSÃO MAPLE */
	
	cout << "with(plots):" << endl;
  	cout << "pointplot([";
    	for (int i = 0 ; i <= N-1 ; i+=1000) {
	    cout << "[" << malha_x[i] << "," << U_old[i] << "]";
        	if (i != N-1)
	        	cout << ",";
	}
    	cout << "]);" << endl << endl;
 
        cout << "# Tempo = " << t_fim - t_ini << endl;
	//cout << "# " << k << " Iteracoes" << endl;
	cout << "# alpha = " << alfa << endl;
        cout << "# gama = " << gama << endl;
        cout << "# Delta T = " << deltaT << endl;
        cout << "# Delta X = " << deltaX << endl;

	
	/* IMPRESSÃO MATLAB 
	cout << "malha_x = [";
	for (int i = 0; i < N-1; i+=1000)
		cout << malha_x[i] << " ";
	cout << "];" << endl;
	
	cout << "B = [";
	for (int i = 0; i < N-1; i+=1000)
		cout << B[i] << " ";
	cout << "];" << endl;	

	cout << "subplot(1,2,1);plot(malha_x,U_inicial); axis([0 1 0 1]); subplot(1,2,2); plot(malha_x, B); axis([0 1 0 1]);";
	
	*/

	return(0);
}
